<!DOCTYPE html>
<html lang="en">

<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>

  <div class="container">
    <div class="text-center my-4">
      <h2>Danh sách người dùng</h2>
    </div>

    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Age</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>13528</td>
          <td>John</td>
          <td>Doe</td>
          <td>23</td>
          <td>...</td>
        </tr>
        <tr>
          <td>23528</td>
          <td>Mary</td>
          <td>Moe</td>
          <td>42</td>
          <td>...</td>
        </tr>
        <tr>
          <td>13348</td>
          <td>July</td>
          <td>Dooley</td>
          <td>54</td>
          <td>...</td>
        </tr>
      </tbody>
    </table>
  </div>
  
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUser = `{
    "description": "Data user",
    "users": [
      {
        "userId": 1,
        "firstname": "Test1",
        "lastname": "User1",
        "age": 18
      },
      {
        "userId": 2,
        "firstname": "Test2",
        "lastname": "User2",
        "age": 19
      },
      {
        "userId": 3,
        "firstname": "Test3",
        "lastname": "User3",
        "age": 18
      },
      {
        "userId": 4,
        "firstname": "Test4",
        "lastname": "User4",
        "age": 20
      },
      {
        "userId": 5,
        "firstname": "Test5",
        "lastname": "User5",
        "age": 21
      },
      {
        "userId": 6,
        "firstname": "Test6",
        "lastname": "User6",
        "age": 20
      }
    ]
  }`;
    var vUser = JSON.parse(gJsonUser)
    var vUserData = vUser.users
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading()
      $(document).on("click", ".user-detail", function(){
          onBtnChiTietClick(this)
      })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    function onPageLoading() {
      loadDataTotable(vUserData)
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function loadDataTotable(paramOjb) {
      $("#user-table tbody").empty() // làm rỗng nội dung của phần tử
      for(var bI = 0; bI < vUserData.length; bI ++){
          var bNewRow = $("<tr/>").appendTo($("#user-table tbody"))
           $("<td/>", {html :paramOjb[bI].userId }).appendTo(bNewRow)
           $("<td/>", {html :paramOjb[bI].firstname }).appendTo(bNewRow)
           $("<td/>", {html :paramOjb[bI].lastname }).appendTo(bNewRow)
           $("<td/>", {html :paramOjb[bI].age }).appendTo(bNewRow)

           var bAction = $("<td/>").appendTo(bNewRow)
          // var bDetailButton = $("<button>")
          //   .addClass ("btn btn-primary")
          //   .html("Chi tiết")
          //   .appendTo(bAction)
           var bDetailButton = $("<button>", {
            html: 'Chi Tiết',
            class: 'btn btn-success user-detail'
           }).data("userid",paramOjb[bI].userId )
           .data("firstname",paramOjb[bI].firstname )
           .data("lastname",paramOjb[bI].lastname )
           .data("age",paramOjb[bI].age )
           .appendTo(bAction)
      } 
    }
    function onBtnChiTietClick(paramOjb){
      console.log("Nút chi tiết được ấn")
      var vUserID = $(paramOjb).data("userid");
      var vFirtName = $(paramOjb).data("firstname");
      var vLastName = $(paramOjb).data("lastname");
      var vAge = $(paramOjb).data("age");
      console.log("UserID: " + vUserID)
      console.log("FirstName: " + vFirtName)
      console.log("LastNAme: " + vLastName)
      console.log("Age: " + vAge)

    }
  </script>
</body>

</html>
​